<template>
  <!-- Login form -->
  <form id="login-form" class="w-full">

    <!-- Error messages -->
    <t-alert v-if="form.globalError" variant="error" class="mb-8" show>
      <p class="text-error">{{ form.globalError }}</p>
    </t-alert>

    <!-- Username -->
    <Input
      v-model="usernameValue"
      name="username"
      :variant="usernameState ? 'primary' : 'error'"
      :state="usernameState"
      :label="$h.capitalize($t('user.username'))"
      :placeholder="$h.capitalize($t('user.username'))"
      :error="getFieldErrorMessage('username')"
      fluid
    />

    <!-- Password -->
    <InputPassword
      v-model="passwordValue"
      name="password"
      :variant="passwordState ? 'primary' : 'error'"
      :state="passwordState"
      :placeholder="$h.capitalize($t('user.password'))"
      :label="$h.capitalize($t('user.password'))"
      fluid
      class="mb-4"
    />

    <!-- Confirm button -->
    <Button
      variant="primary"
      :disabled="!isFormValid"
      @click.native="handleOk"
      fluid
    >
      {{ $t('user.login') | capitalize }}
    </Button>

  </form>
</template>

<script>
// BaseForm
import BaseForm from '@/components/commons/form/BaseForm'
/**
 * Login component
 */
export default {
  name: 'Login',
  extends: BaseForm,
  // 'form' option (see src/components/commons/form/BaseForm)
  form: {
    fields: {
      /**
       * username
       */
      username: {
        // Default: generate 'usernameValue' & 'usernameChanged'
        default: function () {
          return ''
        },
        // Generate: 'isEmailValid'
        isValid: function () {
          return this.usernameValue.length > 0
        }
      },
      /**
       * password
       */
      password: {
        // Default: generate 'passwordValue' & 'passwordChanged'
        default: function () {
          return ''
        },
        // Generate: 'isPasswordValid'
        isValid: function () {
          return this.passwordValue.length > 0
        }
      }
    }
  },
  methods: {
    /**
     * Handle click on 'login' submit button.
     *
     * Call 'auth' module login method ([auth module](../modules/auth)).
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    async handleOk (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors before
      this.resetErrors()
      // Reset loginFailedMessage
      this.loginFailedMessage = false
      // Wait for login function
      const loginResponse = await this.$root.auth.login({
        data: {
          username: this.usernameValue,
          password: this.passwordValue
        }
      })
      // If passed
      if (!(loginResponse instanceof Error)) {
        // Go to redirect or home
        const to = this.$route.query.redirect ? `/#${this.$route.query.redirect}` : '/'
        window.location = to
      // Else parse server error
      } else {
        this.setFormErrors(loginResponse) // Set form errors from response
      }
    }
  }
}
</script>
